	.SECTION	.text
	.ARM
	.CODE 32
	.GLOBAL _start
	.equ	BSSSIZE,	524288
	.include "elf.inc"
	.include "defs.inc"
@---------------------------------------------------------------------
@ START OF CODE
@ this code is ARM asm conversion off linux decompression stub from UPX-1.24
@ not exactly the same, but heavily based on it... 80)
@---------------------------------------------------------------------
_start:
START:
	@------------------------------------------
	@ store registers r3-r9,lr on stack at (sp-32)
	@------------------------------------------
	sub	r0,sp,#32
	stmia	r0, { r3-r9,lr }

	ldr	r4,[sp]				@ get argc
	add	r4,sp,r4,lsl #2
	add	r4,r4,#8			@ r4 points to env[0]

	mov	r7,#0
	@----------------------------
	@ read environment variables
.loop:	ldr	r0 ,[r4], #4
	cmp	r0,#0
	beq	.noUCL

	@ search for UCL env. variable
.cmp0:	add	r1,pc,#(UCLE-.cmp0-8)
	mov	r5,#4
.cmp1:	ldrb	r2,[r0],#1
	ldrb	r3,[r1],#1
	cmp	r2,r3
	bne	.loop
	subs	r5,r5,#1
	bne	.cmp1

	@ we've found UCL env. variable
	@ so we reserve a (160-32)=128 bytes temp buffer on stack
	sub	r7,sp,#160
	@ we copy UCL env string to our buffer (max. 64 bytes length)
	mov	r6,#0
.strl:	ldrb	r1,[r0,r6]
	strb	r1,[r7,r6]
	add	r6,r6,#1
	cmp	r6,#64
	swieq	__NR_exit
	cmp	r1,#0
	bne	.strl
	subs	r6,r6,#1
	@ so here, r7 = buffer on stack  &  r6 = length of UCL var prefix
	bne	.isok

.noUCL:	@-----------------------------------------------------------------------
	@ no UCL env was set,  so we use /tmp as prefix for temporary filename
	@
	sub	r7,sp,#160
.rel1:	ldr	r1,[pc,#(TMPP - .rel1 - 8)]
	str	r1,[r7]
	mov	r6,#4

	@ when here, r7 = buffer on stack  &  r6 = length of tmp path prefix
	@ we now create a temporary file name
	@ with uclAAAA + process PID in hexadecimal form
	@
.isok:	add	r5,r7,r6
.rel2:	add	r2,pc,#(UCLP - .rel2 - 8)
.cpy1:	ldrb	r0,[r2],#1
	strb	r0,[r5],#1
	cmp	r0,#'0'
	bne	.cpy1

	@ convert PID value to hexadecimal ascii
	swi	__NR_getpid
	mov	r2,#3
.hex:	mov	r1,r2,lsl #2
	mov	r1,r0,lsr r1
	and	r1,r1,#0xf
	add	r1,r1,#0x30
	cmp	r1,#0x3A
	addpl	r1,r1,#7
	strb	r1,[r5],#1
	subs	r2,r2,#1
	bpl	.hex
	mov	r0,#0
	strb	r0,[r5]			@ zero terminate the string
	
	@ unlink the file, if it eventually exists
	mov	r0,r7
	swi	__NR_unlink

	@ create temporary file
	mov	r0,r7
	mov	r1,#(O_WRONLY|O_CREAT|O_EXCL)
	_sys_open
	cmp	r0,#-1
	swieq	__NR_exit
	mov	r6,r0				@ store r6 = temp.file fd

.reld:	add	r9,pc,#(blocs-.reld-8)
	ldr	r8,nblocs
	add	r5,r9,r8,lsl #2
@---------------------------------------------------
@ decompression loop:  decompress by bloc of 512 kb
.decomp:
	mov	r0,r5
	ldr	r1,[r9],#4
	add	r5,r5,r1
	ldr	r2,endcode
	add	r2,r2,#0x8000
	sub	r3,r7,#16
	bl	nrv2e_decompress

	@ write decompressed bloc to temp. file
	mov	r0,r6
	mov	r1,r2
	ldr	r2,[r7,#-16]
	_sys_write

	subs	r8,r8,#1
	bne	.decomp

	mov	r0,r6
	_sys_close

	@---------------------------------
	@ re-open temporary file for input
	mov	r0,r7
	mov	r1,#O_RDONLY
	_sys_open
	mov	r6,r0			@ r6 = temp.file fd
	cmp	r0,#-1
	swieq	__NR_exit
	
	@ compute /proc/self/fd/X  name
.rel6:	add	r1,pc,#(procs-.rel6-8)
	add	r1,r1,#14
	@ divide by 10
	mov	r2,#205
	mul	r2,r0,r2
	movs	r2,r2,lsr #11
	beq	.lss10
	add	r3,r2,r2,lsl #2
	sub	r0,r0,r3,lsl #1		@ r0 = r0 - (r3*10)
	add	r2,r2,#0x30
	strb	r2,[r1],#1
.lss10:	add	r0,r0,#0x30
	strb	r0,[r1],#1
	mov	r0,#0
	strb	r0,[r1]

.suck:	add	r0,pc,#(procs-.suck-8)
	mov	r1,#5
	swi	__NR_access
	cmp	r0,#0
	swine	__NR_exit

	@ unlink temp file name
	mov	r0,r7
	swi	__NR_unlink

	@ set fd close on-exec
	mov	r0,r6
	mov	r1,#2		@ F_SETFD
	mov	r2,#1		@ FD_CLOEXEC
	swi	__NR_fcntl

	@-------------------------------------
	@ restore registers r3-r9,lr from stack
	@-------------------------------------
	sub	r0,sp,#32
	ldmia	r0, { r3-r9,lr }
	@-------------------------------------------
	@ do execve on tempfile via /proc/self/fd/..
.rel7:	add	r0,pc,#(procs-.rel7-8)
	ldr	r2,[sp]				@ get argc
	add	r1,sp,#4			@ r1 = &argv[0]
	add	r2,sp,r2,lsl #2
	add	r2,r2,#8			@ r2 points to &env[0]
	swi	__NR_execve

@----------------------------------------------------------
@ NRV2E decompression routine
@ 
@ proto-->   nrv2e_decompress( *src, src_len, *dst, &dst_len)
@
@-----------------------------------------------------------
nrv2e_decompress:
	stmdb	sp!, { r4-r7, lr }
	add	r7,r1,r0
	stmdb	sp!,{ r2, r3 }
	mov	r4,#0
	mvn	r5,r4
	movs	r1,r5,lsl #1
	b	.l1c
	
.l17:	ldrb	r1,[r0],#1
	strb	r1,[r2],#1	/* equiv to movsb */
.l18:	add     r6,r6,r6	/* add  bl,bl (r6 --> ebx) */
	movs	r1,r6,lsl #24
	bne	.l21
.l1c:	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l21:	bcs	.l17
	mov	r3,#1
.l26:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l2f
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l2f:	adcs	r3,r3,r3
	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l3a
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24

.l3a:	bcs	.l_4a
	sub	r3,r3,#1
	add     r6,r6,r6	/* add  bl,bl (r6 --> ebx) */
	movs	r1,r6,lsl #24
	bne	.l_46
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l_46:	adc	r3,r3,r3
	b	.l26

.l_4a:	subs	r3,r3,#3
	bmi	.l__6b
	ldrb	r1,[r0],#1
	add	r3,r1,r3,lsl #8
	mvns	r3,r3
	beq	.l90
	movs	r3,r3,asr #1
	mov	r5,r3
	bcc	.l__76

.l4c:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l55
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l55:	adcs	r4,r4,r4
	b	.l7e

.l__6b:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__74
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__74:	bcs	.l4c			@ jc	0x5e
.l__76:	adds	r4,r4,#1		@ inc	ecx
.l65:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__80
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__80:	bcs	.l4c			@ jc 	0x5e
.l__82:	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__8b
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__8b:	adcs	r4,r4,r4		@ adc	ecx,ecx
	add	r6,r6,r6
	movs	r1,r6,lsl #24
	bne	.l__96
	ldrb	r6,[r0],#1
	adc	r6,r6,r6
	movs	r1,r6,lsl #24
.l__96:	bcc	.l__82
	add	r4,r4,#2
.l7e:	mvn	r1,#1280	@ 0xfffffb00
	cmps	r1,r5
	adc	r4,r4,#2
.movsb:	ldrb	r1,[r2, r5]
	strb	r1,[r2],#1
	subs	r4,r4,#1
	bne	.movsb
	b	.l18
.l90:	cmps	r0,r7
	beq	.la3
	sub	r0,r3,#1
.la3:	mov	r4,r2
	ldmia	sp!,{ r2, r3 }
	sub	r4,r4,r2
	str	r4,[r3]
	ldmia   sp!, {r4-r7, pc}

	

@------------------------------------------
@ STATIC VARS
@
UCLE:	.ascii	"UCL="
procs:	.ascii	"/proc/self/fd/00"
TMPP:	.ascii	"/tmp"
UCLP:	.ascii	"/uclAAA0"

nblocs:		.word	0
blocs:

@------------------------------------------
@------------------------------------------
@ HERE WE INSERT COMPRESSED DATA
@


@---------------------------------------------
	.ALIGN
_data:
_END:
.END


