/*********************************************************************************/
/* UCLX packer, a executable packer for arm based linux...			*/
/* based on UCL library by Markus F.X.J. Oberhumer				*/
/* initially coded for the Sharp Zaurus, but should work in			*/
/* any ARM based linux systems (IPAQ , etc...)					*/
/* coded in january-february 2003 by Cecchinel Stephan (inter.zon@free.fr) 	*/
/*										*/
/* This code his FREE, you can do what you want with it...(even sexual things)	*/
/*										*/
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-============-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
/*										*/
/*										*/
/* "Et tombent les anges en feu, la foudre les entoure de ses clairs,		*/
/* "Brlants dans les flammes ardentes d'Orc... (W.Blake)			*/
/*******************************************************************************/

#include <stdio.h>
#include <ucl/ucl.h>
#include <sys/types.h>
#include <asm/unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

int	errno;
static inline _syscall3(ssize_t,read, int, fd, void *, buf, size_t, count);
static inline _syscall3(ssize_t,write, int, fd, const void *, buf, size_t, count);
static inline _syscall3(off_t,lseek,int,fildes, off_t,offset, int,whence);
static inline _syscall1(int,close, int, fd);
static inline _syscall1(int,unlink,const char *,pathname);


/* We want to compress the data block at `in' with length `IN_LEN' to
 * the block at `out'. Because the input block may be incompressible,
 * we must provide a little more output space in case that compression
 * is not possible.
 */

#ifndef IN_LEN
#define IN_LEN      (512*1024L)
#endif
#define OUT_LEN     (IN_LEN + IN_LEN / 8 + 256)


unsigned int insize[256];
unsigned int outsize[256];

/*---------------------------------------------------------------------------------------*/
/*				ARM NRV2E  decompression header				*/
/*-------------------------------------------------------------------------------------*/
/* we place the header in .text section to be able to call function in it */
#define	HSIZE	984
const unsigned char header[HSIZE]__attribute__((section(".text"))) = {
	0x7f,0x45,0x4c,0x46,0x0a,0x01,0x01,0x61,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x02,0x00,0x28,0x00,0x01,0x00,0x00,0x00,0x4c,0x80,0x00,0x00,0x2c,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0x00,0x20,0x00,0x01,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0xdc,0x03,0x00,0x00,
	0xdc,0x03,0x08,0x00,0x07,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x20,0x00,0x4d,0xe2,
	0xf8,0x43,0x80,0xe8,0x00,0x40,0x9d,0xe5,0x04,0x41,0x8d,0xe0,0x08,0x40,0x84,0xe2,
	0x00,0x70,0xa0,0xe3,0x04,0x00,0x94,0xe4,0x00,0x00,0x50,0xe3,0x12,0x00,0x00,0x0a,
	0x0d,0x1d,0x8f,0xe2,0x04,0x50,0xa0,0xe3,0x01,0x20,0xd0,0xe4,0x01,0x30,0xd1,0xe4,
	0x03,0x00,0x52,0xe1,0xf6,0xff,0xff,0x1a,0x01,0x50,0x55,0xe2,0xf9,0xff,0xff,0x1a,
	0xa0,0x70,0x4d,0xe2,0x00,0x60,0xa0,0xe3,0x06,0x10,0xd0,0xe7,0x06,0x10,0xc7,0xe7,
	0x01,0x60,0x86,0xe2,0x40,0x00,0x56,0xe3,0x01,0x00,0x90,0x0f,0x00,0x00,0x51,0xe3,
	0xf8,0xff,0xff,0x1a,0x01,0x60,0x56,0xe2,0x03,0x00,0x00,0x1a,0xa0,0x70,0x4d,0xe2,
	0x04,0x13,0x9f,0xe5,0x00,0x10,0x87,0xe5,0x04,0x60,0xa0,0xe3,0x06,0x50,0x87,0xe0,
	0xbe,0x2f,0x8f,0xe2,0x01,0x00,0xd2,0xe4,0x01,0x00,0xc5,0xe4,0x30,0x00,0x50,0xe3,
	0xfb,0xff,0xff,0x1a,0x14,0x00,0x90,0xef,0x03,0x20,0xa0,0xe3,0x02,0x11,0xa0,0xe1,
	0x30,0x11,0xa0,0xe1,0x0f,0x10,0x01,0xe2,0x30,0x10,0x81,0xe2,0x3a,0x00,0x51,0xe3,
	0x07,0x10,0x81,0x52,0x01,0x10,0xc5,0xe4,0x01,0x20,0x52,0xe2,0xf6,0xff,0xff,0x5a,
	0x00,0x00,0xa0,0xe3,0x00,0x00,0xc5,0xe5,0x07,0x00,0xa0,0xe1,0x0a,0x00,0x90,0xef,
	0x07,0x00,0xa0,0xe1,0xc1,0x10,0xa0,0xe3,0x05,0x00,0x90,0xef,0x01,0x00,0x70,0xe3,
	0x01,0x00,0x90,0x0f,0x00,0x60,0xa0,0xe1,0xa7,0x9f,0x8f,0xe2,0x94,0x82,0x9f,0xe5,
	0x08,0x51,0x89,0xe0,0x05,0x00,0xa0,0xe1,0x04,0x10,0x99,0xe4,0x01,0x50,0x85,0xe0,
	0x1c,0x21,0x1f,0xe5,0x02,0x29,0x82,0xe2,0x10,0x30,0x47,0xe2,0x2e,0x00,0x00,0xeb,
	0x06,0x00,0xa0,0xe1,0x02,0x10,0xa0,0xe1,0x10,0x20,0x17,0xe5,0x04,0x00,0x90,0xef,
	0x01,0x80,0x58,0xe2,0xf2,0xff,0xff,0x1a,0x06,0x00,0xa0,0xe1,0x06,0x00,0x90,0xef,
	0x07,0x00,0xa0,0xe1,0x00,0x10,0xa0,0xe3,0x05,0x00,0x90,0xef,0x00,0x60,0xa0,0xe1,
	0x01,0x00,0x70,0xe3,0x01,0x00,0x90,0x0f,0x87,0x1f,0x8f,0xe2,0x0e,0x10,0x81,0xe2,
	0xcd,0x20,0xa0,0xe3,0x90,0x02,0x02,0xe0,0xa2,0x25,0xb0,0xe1,0x03,0x00,0x00,0x0a,
	0x02,0x31,0x82,0xe0,0x83,0x00,0x40,0xe0,0x30,0x20,0x82,0xe2,0x01,0x20,0xc1,0xe4,
	0x30,0x00,0x80,0xe2,0x01,0x00,0xc1,0xe4,0x00,0x00,0xa0,0xe3,0x00,0x00,0xc1,0xe5,
	0x79,0x0f,0x8f,0xe2,0x05,0x10,0xa0,0xe3,0x21,0x00,0x90,0xef,0x00,0x00,0x50,0xe3,
	0x01,0x00,0x90,0x1f,0x07,0x00,0xa0,0xe1,0x0a,0x00,0x90,0xef,0x06,0x00,0xa0,0xe1,
	0x02,0x10,0xa0,0xe3,0x01,0x20,0xa0,0xe3,0x37,0x00,0x90,0xef,0x20,0x00,0x4d,0xe2,
	0xf8,0x43,0x90,0xe8,0x1b,0x0e,0x8f,0xe2,0x00,0x20,0x9d,0xe5,0x04,0x10,0x8d,0xe2,
	0x02,0x21,0x8d,0xe0,0x08,0x20,0x82,0xe2,0x0b,0x00,0x90,0xef,0xf0,0x40,0x2d,0xe9,
	0x00,0x70,0x81,0xe0,0x0c,0x00,0x2d,0xe9,0x00,0x40,0xa0,0xe3,0x04,0x50,0xe0,0xe1,
	0x85,0x10,0xb0,0xe1,0x04,0x00,0x00,0xea,0x01,0x10,0xd0,0xe4,0x01,0x10,0xc2,0xe4,
	0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,
	0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,0xf6,0xff,0xff,0x2a,0x01,0x30,0xa0,0xe3,
	0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,
	0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,0x03,0x30,0xb3,0xe0,0x06,0x60,0x86,0xe0,
	0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,0x06,0x60,0xa6,0xe0,
	0x06,0x1c,0xb0,0xe1,0x08,0x00,0x00,0x2a,0x01,0x30,0x43,0xe2,0x06,0x60,0x86,0xe0,
	0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,0x06,0x60,0xa6,0xe0,
	0x06,0x1c,0xb0,0xe1,0x03,0x30,0xa3,0xe0,0xe8,0xff,0xff,0xea,0x03,0x30,0x53,0xe2,
	0x0e,0x00,0x00,0x4a,0x01,0x10,0xd0,0xe4,0x03,0x34,0x81,0xe0,0x03,0x30,0xf0,0xe1,
	0x30,0x00,0x00,0x0a,0xc3,0x30,0xb0,0xe1,0x03,0x50,0xa0,0xe1,0x0e,0x00,0x00,0x3a,
	0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,
	0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,0x04,0x40,0xb4,0xe0,0x1d,0x00,0x00,0xea,
	0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,
	0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,0xf0,0xff,0xff,0x2a,0x01,0x40,0x94,0xe2,
	0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,
	0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,0xe8,0xff,0xff,0x2a,0x06,0x60,0x86,0xe0,
	0x06,0x1c,0xb0,0xe1,0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,0x06,0x60,0xa6,0xe0,
	0x06,0x1c,0xb0,0xe1,0x04,0x40,0xb4,0xe0,0x06,0x60,0x86,0xe0,0x06,0x1c,0xb0,0xe1,
	0x02,0x00,0x00,0x1a,0x01,0x60,0xd0,0xe4,0x06,0x60,0xa6,0xe0,0x06,0x1c,0xb0,0xe1,
	0xf1,0xff,0xff,0x3a,0x02,0x40,0x84,0xe2,0x05,0x1c,0xe0,0xe3,0x05,0x00,0x51,0xe1,
	0x02,0x40,0xa4,0xe2,0x05,0x10,0xd2,0xe7,0x01,0x10,0xc2,0xe4,0x01,0x40,0x54,0xe2,
	0xfb,0xff,0xff,0x1a,0xa9,0xff,0xff,0xea,0x07,0x00,0x50,0xe1,0x00,0x00,0x00,0x0a,
	0x01,0x00,0x43,0xe2,0x02,0x40,0xa0,0xe1,0x0c,0x00,0xbd,0xe8,0x02,0x40,0x44,0xe0,
	0x00,0x40,0x83,0xe5,0xf0,0x80,0xbd,0xe8,0x55,0x43,0x4c,0x3d,0x2f,0x70,0x72,0x6f,
	0x63,0x2f,0x73,0x65,0x6c,0x66,0x2f,0x66,0x64,0x2f,0x30,0x30,0x2f,0x74,0x6d,0x70,
	0x2f,0x75,0x63,0x6c,0x41,0x41,0x41,0x30 };


/**************************************************************************/
/**************************************************************************/

/* pointer to nrv2e_decompress function in header */
void	(*nrv2e_decompress)( ucl_byte *src, ucl_int srclen, ucl_byte *dst, ucl_int *dstlen);


void	compress( char *name, int level);
void	decompress( char *name);
int	isPacked(char *name);


int main(int argc, char *argv[])
{
int	level;


	printf("UCLX v0.2 -- UCL lib. based executable packer..\n\t\t(c) Cecchinel Stephan 2003\n\t\tinter.zon@free.fr\n\n");

	if (argc < 2)
	{
		printf("Usage: %s [-zd] <infile> [level 1-10]\n\n", argv[0]);
		printf("Commands:\n\t-z\tcompress\n\t-d\tdecompress\n\n");
		exit(0);
		}

	if (!strncmp(argv[1], "-z",2))
	{
		if (argc==4)
		{
			level = strtol(argv[3],NULL,10);
			if ((level<1)||(level>10))
				level=6;
			}
		else	level=6;
		compress( argv[2], level);
		}

	if (!strncmp(argv[1], "-d",2))
	{
		decompress( argv[2]);
		}

	exit(0);
}

void	compress( char *name, int level)
{
int i,r,fd,fd2;
ucl_byte *in;
ucl_byte *out;
ucl_uint in_len;
ucl_uint out_len;
struct stat st;
ucl_uint asize, totsize;
ssize_t	res;
unsigned long	nblocks, fsize, temp;
float	per;
char	*tempfile;

/*
 * Step 1: initialize the UCL library
 */
	if (ucl_init() != UCL_E_OK)
	{
		printf("ucl_init() failed !!!\n");
		exit(4);
		}

/*
 * Step 2: allocate blocks
 */
 
	if ( stat(name, &st) != 0)
	{
		printf("error opening %s \n", name);
		exit(-1);
		}
	fsize = (unsigned long)st.st_size;

	if (isPacked(name))
 	{
		printf("\nError, file already packed...\n");
		exit(-1);
		}

	nblocks = (unsigned long)((fsize>>19) + ((fsize & 0x7ffff)!=0));
	if (nblocks>255)
	{
		printf("sorry, source file is too big!!!\n");
		exit(-1);
		}
	printf("Orig. file size = %lu bytes\n", fsize);
 
	in = (ucl_byte *) ucl_malloc(IN_LEN);
	out= (ucl_byte *) ucl_malloc(OUT_LEN);

	printf("compressing...\n");
	
/*
 * Step 3: prepare the input block that will get compressed.
 *         We just fill it with zeros in this example program,
 *         but you would use your real-world data here.
 */
	tempfile = tempnam( "." ,"ucl");
	/* delete destination file, just in case */
	unlink(tempfile);
	/* we create the dest file, with same mode, than orig */
	fd2= open(tempfile,(O_WRONLY | O_CREAT));
	write(fd2, header, HSIZE );
	write(fd2, &nblocks, 4);
	write(fd2, &outsize[0], (4*nblocks));
 
	fd = open(name ,O_RDONLY,0);
	for (totsize=0, asize=0, i=0; i<nblocks; i++)
	{
		/*ucl_memset(in,0,IN_LEN);*/
		res = read(fd,in,IN_LEN);
		in_len = res;
		asize += res;
		fprintf(stdout,"%d/%d:  in=%lu -> ", i+1, nblocks, asize);
		fflush(stdout);
		r = ucl_nrv2e_99_compress(in,in_len,out,&out_len,NULL,level,NULL,NULL);
		if (r == UCL_E_OK)
		{
			insize[i] = res;
			outsize[i]= (unsigned int)out_len;
			totsize += out_len;
			fprintf(stdout,"out=%lu   (%.1f %%)\x0d", totsize, (float)((100.0 * totsize)/asize)  );
			fflush(stdout);
			write(fd2,out,out_len);
		}
		else
		{
		/* this should NEVER happen */
			printf("internal error - compression failed: %d\n", r);
			close(fd); close(fd2);
			exit(-1);
		}



	}
	close(fd);
	/*--------------------*/
	/* modify elf header */
	temp = (unsigned int)( HSIZE+4+(4*nblocks)+totsize);
	lseek(fd2, 0x3C, SEEK_SET);
	write(fd2,&temp,4);
	if (nblocks != 1)
		temp = (unsigned int)(( HSIZE+4+(4*nblocks)+totsize)+0x80000);
	else
		temp = (unsigned int)(( HSIZE+4+(4*nblocks)+totsize)+asize+128);
	write(fd2,&temp,4);
	/*-----------------------------*/
	/* write nblocs & blocs sizes */
	lseek(fd2, HSIZE, SEEK_SET);
	write(fd2, &nblocks, 4);
	write(fd2, &outsize[0], (4*nblocks));
	close(fd2);
	printf("\n\nresult:\n-------\ncompressed size = %lu (%.1f %% of orig.)\n", (totsize+HSIZE+4+(nblocks*4)), (float)((100.0*(totsize+HSIZE+4+(nblocks*4)))/asize) );
	unlink(name);
	if (rename( tempfile, name) != 0)
	{
		printf("sorry, failed to rename %s to %s\n", tempfile,name);
		printf("...do it yourself !!! :)p\n");
		}
	else
	{
		/* we restore orig.file owner & mode */
		chmod(name, st.st_mode);
		chown(name, st.st_uid, st.st_gid);
	}
	ucl_free(out);
	ucl_free(in);
	printf("bye...\n\n");
	exit(0);
}


void	decompress( char *name)
{
size_t	fsize;
struct	stat	st;
int	i,fd,fd2,nblocks,asize;
ucl_byte	*in, *out;
ucl_int		dst_len;
char	*tempfile;

	if ( stat(name, &st) != 0)
	{
		printf("error opening %s \n\n", name);
		exit(-1);
		}
	fsize = (unsigned long)st.st_size;

	if (!isPacked(name))
	{
		printf("Sorry, but %s isn't packed..\n\n", name);
		exit(-1);
		}

#ifdef	arm
	/* this is a dirty trick, it calls directy the nrv2b_decompress inside the header */
	nrv2e_decompress = (void *)&header[540];
#endif
#ifdef	__i386__
	if (ucl_init() != UCL_E_OK)
	{
		printf("ucl_init() failed !!!\n");
		exit(4);
		}
#endif

	tempfile = tempnam( "." ,"ucl");
	/* delete destination file, just in case */
	unlink(tempfile);
	/* we create the dest file, with same mode, than orig */
	fd2= open(tempfile,(O_WRONLY | O_CREAT));

	fd = open(name, O_RDONLY);
	lseek(fd, HSIZE, SEEK_SET);
	read(fd, &nblocks,4);
	read(fd, &insize[0], (nblocks*4));

	in = (ucl_byte *) ucl_malloc(IN_LEN);
	out= (ucl_byte *) ucl_malloc(OUT_LEN);

	printf("decompressing...\n");
	for (asize=0, i=0; i<nblocks; i++)
	{
		read(fd, in, insize[i]);
#ifdef	__i386__
		ucl_nrv2e_decompress_8(in, insize[i], out, &dst_len,NULL);
#endif
#ifdef	arm
		/* if UCLX is compiled for ARM architecture,we directly call header function */
		/* why ? because it is available, and tiny & fast & beautifool...! */
		nrv2e_decompress(in, insize[i], out, &dst_len);
#endif
		/* we write the decompressed bloc, to tempfile */
		asize += dst_len;
		write(fd2, out, dst_len);
		}
	close(fd2);
	unlink(name);
	if (rename( tempfile, name) != 0)
	{
		printf("sorry, failed to rename %s to %s\n", tempfile,name);
		printf("...do it yourself !!! :)p\n");
		}
	else
	{
		/* we restore orig.file owner & mode */
		chmod(name, st.st_mode);
		chown(name, st.st_uid, st.st_gid);
	}
	printf("compressed size: %d bytes\n", fsize);
	printf("decompressed size--> %d bytes\nbye...\n\n", asize);
	

	close(fd);
}

/*---------------------------------------------------------------*/
/* test if a file, is already  packed...			*/
/* search for our decompression header, at is beginning..	*/
/*-------------------------------------------------------------*/
int	isPacked(char *name)
{
char	buff[16];
int	fd;

	fd = open(name, O_RDONLY);
	lseek(fd,0x3B8,SEEK_SET);
	read(fd,buff,14);
	close(fd);
	
	if (!strncmp(buff,"UCL=/proc/self",14))
		return 1;
	else
		return 0;

}

